/*******************************************************************************
**  FILE:	    meshitem.h
**  DESCRIPTION:    Definition details for Mesh Item base classes, i.e. the
**		    base MeshItem class as well as the base Boundary, Material
**		    Probe and Source items which all inherit from MeshItem.
**
**                  This file defines both the base MeshItem base class as well
**                  as four other base items (boundary,material,probe,source) from
**                  which all other mesh items should be based.
**
**
**  AUTHOR:	    Colter McQuay
**  ORGANIZATION:   University Of Victoria
**  SUPERVISOR:	    Dr. Poman So
**
*******************************************************************************/
#ifndef MESHITEMS_H
#define MESHITEMS_H
//#include <QObject>
//#include <QtCore>
//#include <QtGui>
//#include <QGLWidget>

#include "meshitem.h"
#include "boundarymeshitems.h"
#include "materialmeshitems.h"
#include "probemeshitems.h"
#include "sourcemeshitems.h"

#endif // MESHITEMS_H
