/*******************************************************************************
**  FILE:
**  DESCRIPTION:
**
**
**  AUTHOR:	    Colter McQuay
**  ORGANIZATION:   University Of Victoria
**  SUPERVISOR:	    Dr. Poman So
**
*******************************************************************************/

#ifndef PROBEMESHITEMS_H
#define PROBEMESHITEMS_H

#include "meshitem.h"

/**********************************************************
**
**  PROBE MESH ITEM
**
**********************************************************/

class QTOCLMESHSHARED_EXPORT ProbeMeshItem : public MeshItem
{
  Q_OBJECT
private:
    QVector<float> data_;
public:
    ProbeMeshItem();
    ProbeMeshItem(const ProbeMeshItem& other);
    ~ProbeMeshItem();

    ProbeMeshItem& operator=(const ProbeMeshItem& other);
    virtual MeshItem* clone() const;
    virtual operator QVariant() const;

    const QPixmap generateImage(const QSize &size,
                                const QColor border,
                                const QColor fill);

    virtual void draw();
    virtual void addToMesh(MeshEngine &meshEngine);
    virtual void setSize(const Size3D<float> size);
    virtual void setMesh(Mesh *mesh);

    void clearData();
    const QVector<float>& data() const;
    QVector<float>& data();
    void setData(const QVector<float>& vector);
    void appendData(float data);
    void appendData(float* data, int appendedElements);

};

Q_DECLARE_METATYPE(ProbeMeshItem);

QTOCLMESHSHARED_EXPORT QDataStream&
operator<<(QDataStream &out, const ProbeMeshItem& item);

QTOCLMESHSHARED_EXPORT QDataStream&
operator>>(QDataStream &in, ProbeMeshItem& item);

QTOCLMESHSHARED_EXPORT QDebug
operator<<(QDebug dbg,const ProbeMeshItem& item);


#endif // PROBEMESHITEMS_H
