/*******************************************************************************
**  FILE:           
**  DESCRIPTION:    
**
**
**
**  AUTHOR:         Colter McQuay
**  ORGANIZATION:   University Of Victoria
**  SUPERVISOR:     Dr. Poman So
**
*******************************************************************************/

#ifndef DATASET_H
#define DATASET_H

#include <QObject>
#include <QtGui>

class DataSet : public QObject
{
  Q_OBJECT
private:
  QVector<float>* data_;
  QVector<float>  dataContainer_;
  QVector2D       range_;
  QVector2D       domain_;
  QString         title_;
  QString         xAxisTitle_;
  QString         yAxisTitle_;

public:
  explicit DataSet();
  explicit DataSet(QVector<float>& data);
  DataSet(const DataSet& other);

  DataSet& operator=(const DataSet& other);

  void setData();
  void setData(QVector<float>& data);
  void setRange(const QVector2D range);
  void setDomain(const QVector2D domain);
  void setTitle(const QString title = tr(""));
  void setXAxisTitle(const QString title = tr(""));
  void setYAxisTitle(const QString title = tr(""));

  QVector<float>& data();
  const QVector<float>& data() const;
  const QVector2D& range() const;
  const QVector2D& domain() const;
  const QString& title() const;
  const QString& xAxisTitle() const;
  const QString& yAxisTitle() const;

  void analyzeData();

private:


signals:
  void dataChanged();
  void rangeChanged();
  void domainChanged();
  void titleChanged(const QString& title);
  void xAxisTitleChanged(const QString& title);
  void yAxisTitleChanged(const QString& title);

};

#endif // DATASET_H
