/*******************************************************************************
**  FILE:
**  DESCRIPTION:
**
**
**  AUTHOR:	    Colter McQuay
**  ORGANIZATION:   University Of Victoria
**  SUPERVISOR:	    Dr. Poman So
**
*******************************************************************************/

#ifndef ANIMATORGLMANAGER_H
#define ANIMATORGLMANAGER_H

class OpenGLView;
class OpenGLScene;

#include <QtCore>
#include <QObject>
#include "../Threads/meshrenderthread.h"
#include "qtoclmesh.h"

class AnimatorGLManager : public QObject
{
    Q_OBJECT
private:
    QSharedPointer<OpenGLView> animatorViewGL;
    QSharedPointer<OpenGLScene> animatorScene;
    QSharedPointer<Mesh> meshPtr;
    QSharedPointer<MeshRenderThread> renderingThread;


    // Vertex, Index and Color buffers used by OpenGLScene object


public:
//    explicit AnimatorGLManager(QObject *parent = 0);
    AnimatorGLManager(QSharedPointer<Mesh> mesh,QObject *parent = 0);
    //AnimatorGLManager(const AnimatorGLManager &other);
    ~AnimatorGLManager();
    //AnimatorGLManager& operator=(const AnimatorGLManager &other);

    QSharedPointer<QWidget> getViewPtr()const;
private:
    void initialize();
    void connectSignals();

public slots:
    void setMesh(QSharedPointer<Mesh> newMesh);
    void meshDataChanged();

};

#endif // ANIMATORGLMANAGER_H
