/*******************************************************************************
**  FILE:
**  DESCRIPTION:
**
**
**  AUTHOR:	    Colter McQuay
**  ORGANIZATION:   University Of Victoria
**  SUPERVISOR:	    Dr. Poman So
**
*******************************************************************************/

#ifndef EDITORVIEW2D_H
#define EDITORVIEW2D_H
#include "editorview.h"

class EditorView2D : public EditorView
{
  Q_OBJECT

private:
  Point3D<float>  hAxis_;
  Point3D<float>  vAxis_;

//  bool            hAxisInverted_;
//  bool            vAxisInverted_;

public:
  explicit EditorView2D(Editor *parent,
                        Point3D<float> hAxis, Point3D<float> vAxis);

  const Point3D<float> viewMask() const;
  const Point3D<float> hAxis() const;
  const Point3D<float> vAxis() const;
  bool isHAxisInverted() const;
  bool isVAxisInverted() const;

  void setupGLView(QSize viewSize);

  bool viewHasMouseTracking() const;
  void setViewMouseTracking(bool enable);

protected:
  void wheelEvent(QWheelEvent *wheelEvent);
  bool eventFilter(QObject * object, QEvent *event);


signals:
  void mousePressed(const QPoint mousePos,
                    Qt::MouseButtons buttons,
                    Qt::KeyboardModifiers modifiers);
  void mouseReleased(const QPoint mousePos,
                     Qt::MouseButtons buttons,
                     Qt::KeyboardModifiers modifiers);
  void mouseMoved(const QPoint mousePos,
                  Qt::MouseButtons buttons,
                  Qt::KeyboardModifiers modifiers);

public slots:
  void sceneDepthsChanged(Point3D<float> depths);

private slots:
  void scrollViewCameraH(int scrollValue);
  void scrollViewCameraV(int scrollValue);
};

#endif // EDITORVIEW2D_H
